export interface RequestData {
    interfaceName?: string;
    url?: string;
    retryTimes?: number;
    useTime?: number;
    server?: string;
    query?: object;
    body?: object;
    response?: any;
    options?: {
        accept?: string;
        postType?: string;
        headers?: object;
        httpMethod?: string;
    };
}
export declare type HandleFunBefore = (data: RequestData) => Promise<RequestData>;
export declare type HandleFunAfter = (data: any) => Promise<any>;
export interface RequestConfig {
    retries?: number;
    factor?: number;
    minTimeout?: number;
    retryWhen50x?: boolean;
    retryWhenTimeout?: boolean;
    retryWhenConnectError?: boolean;
    timeOut?: number;
    afterSend?: HandleFunAfter;
    beforeSend?: HandleFunBefore;
}
export declare type ResponseData = {
    err: string;
    status: string;
} & object;
export declare class Request {
    private config;
    private retry;
    constructor(config?: RequestConfig);
    sendData(url: any, data: RequestData): Promise<ResponseData>;
    sendDataRetry(url: any, data: RequestData): Promise<ResponseData>;
    shouldRetry(res: any): boolean;
    get(url: any, data: RequestData): Promise<ResponseData>;
    post(url: any, data: RequestData): Promise<ResponseData>;
    put(url: any, data: RequestData): Promise<ResponseData>;
}
